<?

function tag_attr($attr=array()) {
  $s='';
  foreach($attr as $name=>$val) $s.=' '.$name.'="'.$val.'"';
  return $s;
  }
function tag_head($tag,$attr=array(),$single=false) {
  $s="<$tag".tag_attr($attr).($single?' /':'').'>';
  return($s);
  }
function tag_tail($tag) {
  return "</$tag>";
  }

function form_button($caption,$action='',$title='',$type='button') {
  $s='';
  if ($title!='') $s.=' title="'.$title.'"';
  if ($action!='') $s.=' onclick="'.$action.'"';
?>
<input type="<?=$type?>" class="button" value="<?=$caption?>"<?=$s?>
       onmousedown="this.className='button button_active'"
       onmouseup="this.className='button'">
<?
  }

function form_start($action,$id='form',$method='post',$enctype='multipart/form-data') {
?>
<form action="<?=$action?>" method="<?=$method?>" enctype="<?=$enctype?>" id="<?=$id?>">
<?
  }

function form_end() {
?>
</form>
<?
  }

function form_hidden($name,$val='') {
  $id=str_replace('[','_',str_replace(']','_',$name));
?>
<input type="hidden" name="<?=$name?>" value="<?=htmlspecialchars($val)?>" id="<?=$id?>">
<?
  }

function form_select($name,$now,$options=array(),$colors=array()) {
?>
<select name="<?=$name?>" id="<?=str_replace('[','_',str_replace(']','_',$name))?>">
<?
foreach ($options as $par=>$val) {
  if ($par==$now) $sel=' selected'; else $sel='';
  if (isset($colors[$par]))
    $style=' style="color:'.$colors[$par].'"';
  else $style='';
?>
<option<?=$style?> value="<?=$par?>"<?=$sel?>><?=$val?></option>
<? } ?>
</select>
<?
  }
function form_select2($name,$now,$options=array()) {
?>
<select name="<?=$name?>">
<?
foreach ($options as $par=>$val) {
?>
<optgroup label="<?=$par?>">
<?
  foreach ($val as $id=>$opt) {
    if ($id==$now) $sel=' selected'; else $sel='';
?>
  <option value="<?=$id?>"<?=$sel?>><?=$opt?></option>
<? } ?>
</optgroup>
<? } ?>
</select>
<?
  }
function form_text($name,$now='',$size='100%',$hint='') {
  if (strstr($size,'px') or strstr($size,'%')) $s=' style="width:'.$size.'"'; else $s=' size="'.$size.'"';
  $id=str_replace('[','_',str_replace(']','_',$name));
?>
<input type="text" class="text" name="<?=$name?>" value="<?=htmlspecialchars($now)?>"<?=$s?> id="<?=$id?>">
<? if ($hint!='') { if ($hint[0]!='?') echo $hint; else { ?>
<a href="javascript:void(alert('<?=substr($hint,1)?>'))" title='<?=substr($hint,1)?>'>(?)</a>
<?  } }
  }
function form_pass($name,$now='',$size='100%',$hint='') {
  if (strstr($size,'px') or strstr($size,'%')) $s=' style="width:'.$size.'"'; else $s=' size="'.$size.'"';
?>
<input type="password" class="text" name="<?=$name?>" value="<?=$now?>"<?=$s?>>
<? if ($hint!='') { if ($hint[0]!='?') echo $hint; else { ?>
<a href="javascript:void(alert('<?=substr($hint,1)?>'))" title='<?=substr($hint,1)?>'>(?)</a>
<?  } }
  }
function form_textarea($name,$now='',$w=0,$h=5) {
  if (!$w) $w='100%';
  if (strstr($w,'%') or strstr($w,'px')) $width=' style="width:'.$w.'"'; else $width=' cols="'.$w.'"';
  $height=' rows="'.$h.'"';
  $id=str_replace('[','_',str_replace(']','_',$name));
?>
<textarea id="<?=$id?>" name="<?=$name?>"<?=$width.$height?>><?=$now?>
</textarea>
<?
  }

function form_checkbox($name,$now=FALSE,$hint='',$title='') {
  if ($now) $c=' checked'; else $c='';
  if ($title!='') $c.=' title="'.$title.'"';
  if ($name!='') $c.=' id="'.str_replace('[','_',str_replace(']','_',$name)).'"';
?>
<input class="checkbox" type="checkbox" name="<?=$name?>"<?=$c?>> <?=$hint?>
<?
  }

function form_radio($name,$val='',$hint='',$on=FALSE) {
  if ($on) $c=' checked'; else $c='';
  if ($hint!='' and $hint[strlen($hint)-1]!='\n') $hint.='&nbsp;';
?>
<input type="radio" class="radio" name="<?=$name?>"<?=$c?> value="<?=$val?>"> <?=$hint?>
<?
  }

function form_submit($title='') {
  form_button($title,'','','submit');
  }
function form_reset($title='') {
?>
<input type="reset" class="button" value="<?=$title?>">
<?
  }

function form_file($name='file',$size=32,$max=0) {
  if ($max!=0) { ?>
<input type="Hidden" name="MAX_FILE_SIZE" value="<?=$max?>">
<? } ?>
<input type="file" class="text" size="<?=$size?>" name="<?=$name?>">
<?
  }

function gen_tr_id() {
  global $TR_ID,$TR_ID_N;
  if ($TR_ID=='') return('');
  if ($TR_ID_N=='') $TR_ID_N=0;
  $TR_ID_N++;
  return(' id="'.$TR_ID.$TR_ID_N.'" ');
  }

function param_start($title,$action,$id='form',$style='') {
  if (!$id) $id='form'; $winid="win_$id";
?>
<form action="<?=$action?>" method="POST" enctype="multipart/form-data" id="<?=$id?>">
<?
  if ($title!='') echo win_start($title,$style,$winid);
  else echo frame_start($style,$winid);
  }

function param_head($title='',$class='p') {
?>
<tr<?=gen_tr_id()?>>
  <th class="p r"><?=$title?></th><td class="<?=$class?>">
<?
  }
function param_head2($b=array(),$header=false) {
  $tag=$header?'th':'td';
?>
<tr<?=gen_tr_id()?>>
<?
  $a=array_merge(array('class'=>'p c','colspan'=>2),$b);
  echo tag_head($tag,$a);
  }
function param_tail($header=false) {
  $tag=$header?'th':'td';
  echo "</$tag></tr>\n";
  }

function param_bar() {
?>
<tr<?=gen_tr_id()?>>
  <td class="bar" colspan="2"></td></tr>
<?
  }

function param_select($title,$name,$now,$options,$colors=array()) {
  param_head($title);
  form_select($name,$now,$options,$colors);
  param_tail();
  }
function param_select2($title,$name,$now,$options) {
  param_head($title);
  form_select2($name,$now,$options);
  param_tail();
  }
function param_text($title,$name,$now='',$size=0,$hint='') {
  param_head($title);
  form_text($name,$now,$size,$hint);
  param_tail();
  }
function param_pass($title,$name,$now='',$size=0,$hint='') {
  param_head($title);
  form_pass($name,$now,$size,$hint);
  param_tail();
  }
function param_textarea($title,$name,$now='',$w=0,$h=5) {
?>
<tr<?=gen_tr_id()?>>
<? if ($title!='') { ?>
<th class="p r"><?=$title?></th><td class="p">
<? } else { ?>
<td colspan="2" class="p c">
<? } ?>
<? form_textarea($name,$now,$w,$h); ?>
</td></tr>
<?
  }

function param_checkbox($title,$name,$now=FALSE,$hint='') {
  param_head($title);
  form_checkbox($name,$now,$hint);
  param_tail();
  }

function param_radio($title,$name,$val='',$hint='',$on=FALSE) {
  param_head($title);
  form_radio($name,$val,$hint,$on);
  param_tail();
  }

function param_file($title,$name='file',$size=32,$max=0) {
  param_head($title);
  form_file($name,$size,$max);
  param_tail();
  }

function param_button($title,$text,$action='',$hint='') {
  param_head($title);
  form_button($text,$action,$hint);
  param_tail();
  }

function param_submit($title,$cancel='',$reset='') {
?>
<tr<?=gen_tr_id()?>><th colspan="2" class="p c">
<?
form_submit($title);
if ($reset!='') form_button('','',' ','reset'); ?>
<? if ($cancel!='') form_button('',$cancel,' ','button'); ?>
</th></tr>
<?
  }

function param_data($title,$data,$class='p') {
?>
<tr<?=gen_tr_id()?>><th class="p r"><?=$title?></th><td class="<?=$class?>">
<?=$data?>
</td></tr>
<?
  }

function param_end() {
  echo win_end();
?>
</form>
<? }

function icon($name,$img,$url,$title,$class='') {
  global $CFG;
  $src="$CFG[PATH]/$img";
  if ($title=='') $title=$name;
  $s=tag_head('center');
  $s.=tag_head('div',array('class'=>'icon','title'=>$title));
  $s.=tag_head('a',array('class'=>"icon $class",'href'=>root_link_url($url)));
  $s.=tag_head('img',array('class'=>'icon','src'=>$src,'alt'=>$img));
  $s.="<br>$name";
  $s.=tag_tail('a').tag_tail('div').tag_tail('center');
  return($s);
  }

function make_style($a=array()) {
  $x=array(); foreach ($a as $key=>$val) $x[]="$key:$val";
  return implode('; ',$x);
  }

function button($text,$a=array()) {
  global $CFG;
  $omd="this.className='side side_active'";
  $omu="this.className='side'";
  echo tag_head('button',array_merge(array('class'=>'side','onmousedown'=>$omd,'onmouseup'=>$omu),$a));
  echo $text;
  echo tag_tail('button');
  }
function button_js($text,$action,$a=array()) {
  button($text,array_merge(array('type'=>'button','onclick'=>$action),$a));
  }
function button_to($text,$url,$a=array()) {
  button_js($text,"location.href='$url'",$a);
  }
function button_subto($text,$url,$a=array()) {
  global $FORM_ID;
  button_js($text,"document.getElementById('$FORM_ID').action='$url'; document.getElementById('$FORM_ID').submit();",$a);
  }
function button_submit($text,$a=array()) {
  button($text,array_merge(array('type'=>'submit'),$a));
  }

?>