<?
if ($_SERVER['argc']<2) { die('Fail'); }
include("../../service.php");
include("include.php");

$hid=2;
$DL='domains.txt';
$FS=array('/dev/sdb1','/dev/sdc1');
$SA='sa.log';
$TR='traf.log';
$users=array();

switch ($_SERVER['argv'][1]) {

case 'traffic': 
  echo "  Processing domains...\r\n";
  if (!$f=fopen("stat/$hid/$DL",'r')) die("Cannot open file '$DL' for reading!\r\n");
  $dl=array();
  while (!feof($f)) {
    $s=strtolower(trim(fgets($f)));
    if ($s=='') continue;
    $z=preg_split("/[\s,]+/",$s);
    if (count($z)<2) continue;
    if (substr($z[0],0,4)=='www.') $s=substr($z[0],4);
    $d=array('user'=>$z[1],'traf'=>0);
    $dl[$z[0]]=$d;
    }
  echo "  Processing traffic...\r\n";
  if (!$f=fopen("stat/$hid/$TR",'r')) die("Cannot open file '$TR' for reading!\r\n");
  $tr=array();
  while (!feof($f)) {
    $s=trim(fgets($f));
    if ($s=='') continue;
    $z=preg_split("/[\s,]+/",$s);
    if (count($z)<2) continue;
    if (!isset($tr[$z[0]])) $tr[$z[0]]=$z[1]; else $tr[$z[0]]+=$z[1];
    }
  foreach ($tr as $d=>$b) {
    $d=strtolower($d);
    if (substr($d,0,4)=='www.') $d=substr($d,4);
    if (!isset($dl[$d])) { echo "  Unknown domain '$d', traffic: $b bytes\r\n"; continue; }
    $dl[$d]['traf']+=$b;
    }
  mysql_query("delete from hdomains where host=$hid");  
  foreach ($dl as $d=>$v) {
    mysql_query("insert into hdomains set host=$hid,login='$v[user]',domain='$d',traf='$v[traf]'");
    }
  echo "  Done, ".count($dl)." domains processed.\r\n";
  break;

case 'count':

$host=get_sql_row('hosts',"id=$hid");
$serv=get_sql_array('hserv.id.cat');
$cats=get_sql_array('hservices.id.class');
$orders=get_sql_table('orders.id',"host=$hid");

if (!$f=fopen("stat/$hid/$SA",'r')) {
  die("Cannot open file '$SA' for reading!\r\n");
  }
$sa=array();
while (!feof($f)) {
  $s=trim(fgets($f));
  $z=preg_split("/[\s,]+/",$s);
  if (count($z)<5) continue;
  $sa[$z[0]]=str_replace('cp','',$z[3]);
  }

$p=0;
foreach ($orders as $id=>$o) {
  if (!strstr('HF',$cats[$serv[$o['service']]['cat']]['class'])) continue;
  if ($o['login']=='') continue;
  $l=$o['login'];
  $u=array('hdd'=>0,'cpu'=>0,'tr'=>0,'p'=>0);
  
  $x=array();
  exec("quota $o[login]",$x);
  foreach ($x as $s) {
    if (strstr($s,$FS)) echo "  $s\r\n";
    foreach ($FS as $w) if (strstr($s,$w)) {
      $z=preg_split("/[\s,]+/",trim($s));
      $u['hdd']+=$z[1];
      }
    }
  $u['hdd']=round($u['hdd']/(1024*1024),3);
  $u['p']+=3*$u['hdd'];
  
  $u['cpu']=isset($sa[$l])?$sa[$l]:0;
  $u['p']+=($host['cpumhz']/1000)*0.3*($u['cpu']/10);
  
  if ($u['p']<0.5) $u['p']=0.5;
  echo "User $l, order $id: hdd $u[hdd] GB, cpu $u[cpu] minutes = $u[p]\r\n";
  $p+=$u['p'];
  }

  echo "Total = $p\r\n";

  break;

default: 
  echo "Wrong parameter\r\n";

}

?>