<?

function xml_start() {
  header("Content-type: text/xml; charset=windows-1251");
  header("Cache-Control: no-store, no-cache, must-revalidate");
  header("Cache-Control: post-check=0, pre-check=0", false);
  echo '<?xml version="1.0" encoding="windows-1251"?>'; echo "\n\n";
  }

function xml_tag_head($tag,$attr=array(),$close=false) {
  $s="<$tag".tag_attr($attr).($close?' /':'').'>';
  return($s);
  }

function xml_tag_tail($tag) {
  return "</$tag>";
  }

function xml_head($tag,$attr=array(),$close=false) {
  echo xml_tag_head($tag,$attr,$close)."\n";
  }

function xml_tail($tag) {
  echo xml_tag_tail("$tag")."\n";
  }

function xml_tag($tag=false,$val='') {
  if (!$tag) return;
  echo "<$tag>$val</$tag>\n";
  }

function directory($dir) {
  $a=array();
  if (!$d=@opendir($dir)) return($a);
  while ($f=readdir($d)) $a[]=$f;
  closedir($d);
  return($a);
  }

function str_sep($c,$s,$n=0) {
  $e=explode($c,$s); return($e[$n]);
  }

function secure($s) {
  return(addslashes(str_replace('&#','',$s)));
  }
function unsecure($s) {
  return(stripslashes($s));
  }

function serial($a,$c='=') {
  $s='';
  foreach ($a as $p=>$v) {
    if (trim($v)=='') continue;
    if ($s!='') $s.=' ';
    $s.=$p.$c.$v; }
  return($s);
  }
function unserial($s,$c='=') {
  if (trim($s)=='') return(array());
  $a=explode(' ',$s);
  $aa=array();
  foreach ($a as $v) { list($ap,$av)=explode($c,$v,2); $aa[$ap]=$av; }
  return($aa);
  }

function str_to_web($s) {
  return(htmlspecialchars($s,ENT_QUOTES,'CP1251'));
  }
function str_single($s) {
  $rn=array("\r\n","\n","\r");
  return(str_replace($rn,' ',$s));
  }
function str_from_web($s) {
  return(html_entity_decode($s,ENT_QUOTES));
  }

function make_sql_set($a=array(),$convert=false) {
  foreach ($a as $p=>$v) {
    if ($convert) $v=addslashes($v);
    $a[$p]="`$p`='".$v."'";
    }
  return(implode(',',$a));
  }
function get_sql_fields($table) {
  $r=mysql_query("select * from $table limit 1");
  $a=array();
  for ($i=0; $i<mysql_num_fields($r); $i++)
    $a[mysql_field_name($r,$i)]='';
  return($a);
  }
function get_sql_count($table,$clause='') {
  if ($clause!='') $clause="where $clause";
  $q="select count(*) from $table $clause";
  $r=mysql_query($q) or die("GET_SQL_COUNT $table: ".mysql_error()." Q=$q");
  list($n)=mysql_fetch_row($r);
  return($n);
  }
function get_sql_value($from,$clause='',$order='') {
  $t=explode('.',$from); $table=&$t[0]; $col=&$t[1];
  if ($clause!='') $clause="where $clause";
  if ($order=='') $order="order by $col"; else $order="order by $order";
  $q="select $col from $table $clause $order limit 1";
  $r=mysql_query($q) or die("GET_SQL_VALUE $from: ".mysql_error()." Q=$q");
  if (mysql_num_rows($r)>0) { list($s)=mysql_fetch_row($r); return($s); }
  else return false;
  }
function get_sql_row($table,$clause='',$order='') {
  if ($clause!='') $clause="where $clause";
  if ($order!='') $order="order by $order";
  $q="select * from $table $clause $order limit 1";
  $r=mysql_query($q) or die("GET_SQL_ROW $table: ".mysql_error()." Q=$q");
  if (mysql_num_rows($r)>0) return(mysql_fetch_assoc($r)); else return(false);
  }
function get_sql_array($from,$clause='',$order='') {
  $t=explode('.',$from); $table=&$t[0]; $col1=&$t[1]; $col2=&$t[2];
  if ($order=='') $order="order by $col2"; else $order="order by $order";
  if ($clause!='') $clause="where $clause";
  $q="select $col1,$col2 from $table $clause $order";
  $r=mysql_query($q) or die("GET_SQL_ARRAY $from: ".mysql_error()." Q=$q");
  $a=array();
  while (list($x1,$x2)=mysql_fetch_row($r)) $a[$x1]=$x2;
  return($a);
  }
function get_sql_table($from,$clause='',$order='',$extra='') {
  $t=explode('.',$from); $table=&$t[0]; $key=&$t[1];
  if ($order=='') $order="order by $key"; else $order="order by $order";
  if ($clause!='') $clause="where $clause";
  if ($extra!='') $extra=",$extra";
  $q="select * $extra from $table $clause $order";
  $r=mysql_query($q) or die("GET_SQL_TABLE $from: ".mysql_error()." Q=$q");
  $a=array();
  while ($x=mysql_fetch_assoc($r)) {
    $id=$x[$key]; unset($x[$key]); $a[$id]=$x; }
  return($a);
  }

function fetch_cfg($module='core') {
  global $CFG;
  if (!isset($CFG) or !is_array($CFG)) $CFG=array();
  $CFG=array_merge($CFG,get_sql_array('config.par.val',"module='$module'"));
  }

function fetch_par() {
  global $MODULES,$PAR;
  $list=array();
  foreach ($MODULES as $code=>$m) if ($m['active']) $list[]="module='$code'";
  $list=implode(' or ',$list);
  $PAR=array();
  $q="select module,par,val from config where module!='core' and ($list)";
  $r=mysql_query($q);
  while (list($m,$p,$v)=mysql_fetch_row($r)) $PAR[$m][$p]=$v;
  }

function store_cfg_val($par,$val) {
  global $MODULE;
  mysql_query("replace config set module='$MODULE',par='$par',val='$val' where module='$MODULE' and par='$par'");
  return $val;
  }

function store_cfg($a=array()) {
  global $MODULE;
  foreach ($a as $par=>$val) {
    mysql_query("replace config set module='$MODULE',par='$par',val='$val' where module='$MODULE' and par='$par'");
    }
  return $a;
  }

function js_redir($url) {
echo <<<CODE
<script language="JavaScript">
location.href='$url';
</script>
CODE;
  }

function js_win_cmd($dx,$dy,$url,$name='smallwin',$scroll=false) {
  $sb=$scroll?'yes':'no';
  return("$name=window.open('$url','$name','status=no,scrollbars=$sb,width=$dx,height=$dy')");
  }

function js_win_line($dx,$dy,$url,$name='smallwin',$scroll=false) {
  return('javascript:void('.js_win_cmd($dx,$dy,$url,$name,$scroll).')');
  }

function js_win_open($dx,$dy,$url,$name='smallwin') { ?>
<script language="JavaScript">
<?=js_win_line($dx,$dy,$url,$name);?>
</script>
<? }

function js_alert($s='') {
?>
<script language="JavaScript">alert("<?=$s?>");</script>
<? }

function js_ask_line($s='',$url) {
  return("if (confirm('$s')) location.href='$url'");
  }

function action_img_file($code) {
  //$file=dir_theme($code.'.gif','ico');
  //if (file_exists($file))
  $file=path_theme($code.'.gif','act');
  return($file);
  }
function action_img($code,$attr=array()) {
  $i=array('class'=>'action','border'=>'0','src'=>action_img_file($code));
  $a=array_merge($i,$attr);
  return tag_head('img',$a,true);
  }
function a_action($name,$img,$url,$text=FALSE,$target='') {
  global $CFG;
  $a=array('class'=>'action','href'=>$url,'title'=>$name);
  if ($target!='') $a['target']=$target;
  $s=tag_head('a',$a);
  $s.=action_img($img);
  if ($text) $s.=$text;
  $s.=tag_tail('a');
  return($s);
  }
function a_action_js($name,$img,$js,$text=FALSE) {
  return(a_action($name,$img,"javascript:void($js)",$text));
  }
function a_action_submit($name,$img,$id,$text=FALSE) {
  $url="javascript:void(document.getElementById('$id').submit())";
  return(a_action($name,$img,$url,$text));
  }
function a_action_ask($name,$img,$url,$ask='') {
  if ($ask=='') $ask=' ?';
  $url='javascript:'.js_ask_line($ask,$url);
  return(a_action($name,$img,$url));
  }

function message($msg,$title=' ') {
echo <<<CODE
<center>
{WIN_START=$title,margin-bottom:10px,message}
<div class="message">
$msg
</div>
{WIN_END}
</center>
<script language="JavaScript">
setTimeout("document.getElementById('message').style.display='none'",2000);
</script>
CODE;
  }

function redir_msg($url,$msg,$title=' ') {
echo <<<CODE
<center>
{WIN_START=$title}
<div id="message" class="message">
$msg
<br>
<span class="note"><a href="$url">
    ,  .
</a></span>
</div>
{WIN_END}
</center>
<script language="JavaScript">
setTimeout("location.href='$url';",1500);
</script>
CODE;
  }

function tooltip($tip,$id='0',$freeze=false) {
  global $CFG;
  $tip=str_single($tip);
  $s=tag_head('a',array('class'=>'action','href'=>'javascript:void(0)'));
  $img=path_theme('info.gif','act');
  $a=array('src'=>$img,'class'=>'x16y16','id'=>"ttip_$id",'border'=>'0');
  if ($freeze) $a['onclick']="tip_show(event,'ttip_$id','$tip')";
  $a['onmouseover']="tip_show(event,false,'$tip')";
  $a['onmouseout']="tip_hide()";
  $s.=tag_head('img',$a).tag_tail('a');
  return($s);
  }

function html_a($href='',$text='',$title='',$a=array()) {
  if ($href=='') $href='javascript:void(0)';
  if (!isset($a['href'])) $a['href']=$href;
  if (!isset($a['title']) and $title!='') $a['title']=$title;
  xml_head('a',$a); echo $text; xml_tail('a');
  }

function add_image($code,$fname,$tfname,$max,$tmax) {
  if (!is_uploaded_file($_FILES[$code]['tmp_name'])) return(false);
  $ii=getimagesize($_FILES[$code]['tmp_name']);
  switch ($ii[2]) {
    case IMAGETYPE_GIF: $ok=true; $i=imagecreatefromgif($_FILES[$code]['tmp_name']); break;
    case IMAGETYPE_JPEG: $ok=true; $i=imagecreatefromjpeg($_FILES[$code]['tmp_name']); break;
    case IMAGETYPE_PNG: $ok=true; $i=imagecreatefrompng($_FILES[$code]['tmp_name']); break;
    default: $ok=false;
    }
  if (!$ok) return(false);
  $ix=$ii[0]; $iy=$ii[1];
  $nx=$ix>$iy?$max:round($ix/$iy*$max);
  $ny=round($nx/$ix*$iy);
  $tx=$ix>$iy?$tmax:round($ix/$iy*$tmax);
  $ty=round($tx/$ix*$iy);
  $ni=imagecreatetruecolor($nx,$ny); imageinterlace($ni,1);
  imagecopyresampled($ni,$i,0,0,0,0,$nx,$ny,$ix,$iy);
  imagejpeg($ni,$fname,95); chmod($fname,0644);
  $nt=imagecreatetruecolor($tx,$ty); imageinterlace($nt,1);
  imagecopyresampled($nt,$i,0,0,0,0,$tx,$ty,$ix,$iy);
  imagejpeg($nt,$tfname,95); chmod($tfname,0644);
  unlink($_FILES[$code]['tmp_name']);
  return(true);
  }

function data_set($par,$val) {
  $_SESSION['data'][$par]=$val;
  }

function data_get($par,$val) {
  if (isset($_SESSION['data'][$par]))
    return($_SESSION['data'][$par]);
  else {
    $_SESSION['data'][$par]=$val;
    return($val);
    }
  }

function make_menu() {
  global $UCATS,$PCATS,$USER,$MODULES;
  $m=array();
  foreach ($PCATS as $cat=>$name) $m[$cat]=array('name'=>$name,'list'=>array());
  $r=mysql_query("
select module,unit,cat,name,descr,access from pages where `on`='1' and in_menu='1'
union
select module,code,cat,name,descr,access from units where in_menu='1'
order by cat,module,unit") or die(mysql_error());
  while ($p=mysql_fetch_assoc($r)) {
    if ($p['access'] and !strstr($USER['access'],$p['access'])) continue;
    if (!isset($MODULES[$p['module']]) or !$MODULES[$p['module']]['active']) continue;
    $url=module_url($p['module'],$p['unit']);
    $l=array('name'=>$p['name'],'title'=>$p['descr'],'url'=>$url);
    $m[$p['cat']]['list'][]=$l;
    }
  return $m;
  }

?>