<?

function dir_theme($file='',$subdir='') {
  global $CFG;
  $s="themes/$CFG[SITE_THEME]/";
  if ($subdir!='') $s.=$subdir.'/';
  if ($file!='') $s.=$file;
  return($s);
  }

function path_theme($file='',$subdir='') {
  global $CFG;
  $s="$CFG[PATH]/t/$CFG[SITE_THEME]/";
  if ($subdir!='') $s.=$subdir.'/';
  if ($file!='') $s.=$file;
  return($s);
  }

function page_start($title='',$bodyclass='') {
  global $CFG,$META_TAG,$MODULES,$MODULE;
  $stylefile=path_theme('style.css');
  $t=$title!=''?$title.' | '.$CFG['SITE_NAME']:$CFG['SITE_TITLE'];
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>






<div class="addthis_toolbox">  
   <div class="custom_images">
<noindex>
<a rel="nofollow" class="addthis_button_twitter" title="  Twitter"><img src="/share42/twitter.png" /></a><br>
<a rel="nofollow" class="addthis_button_facebook" title="  Facebook"><img src="/share42/facebook.png" /></a><br>
<a rel="nofollow" class="addthis_button_vk" title="  "><img src="/share42/vkontakte.png" /></a><br>
<a rel="nofollow" class="addthis_button_mymailru" title="   "><img src="/share42/mail-ru.png" /></a><br>
<a rel="nofollow" class="addthis_button_googlebuzz" title="  Google Buzz"><img src="/share42/googleBuzz_48.png" /></a><br>
<a rel="nofollow" class="addthis_button_livejournal" title="  Livejournal"><img src="/share42/livejournal.png" /></a></noindex>
    </div>
</div>
<script type="text/javascript" src="http://s7.addthis.com/js/250/addthis_widget.js#username=YOUR-ACCOUNT-ID" charset="windows-1251"></script>














  <title><?=$t?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
<?
  foreach ($META_TAG as $name=>$content) {
    echo tag_head('meta',array('name'=>$name,'content'=>$content))."\n";
    }
?>
  <link rel="icon" href="<?=path_theme('favicon.ico')?>">
  <link rel="StyleSheet" type="text/css" href="<?=$stylefile?>">
  <script type="text/javascript" language="JavaScript" src="<?=root_link_url('core/func.js')?>"></script>
<?
  if (isset($CFG['THEME_JS'])) {
    echo tag_head('script',array('type'=>'text/javascript','language'=>'JavaScript','src'=>path_theme('theme.js')));
    echo tag_tail('script')."\n";
    }
  if ($MODULES[$MODULE]['css'])
      echo tag_head('link',array('rel'=>'StyleSheet','type'=>'text/css','href'=>root_link_url("modules/$MODULE/style.css")))."\n";
  if ($MODULES[$MODULE]['js']) {
    echo tag_head('script',array('type'=>'text/javascript','language'=>'JavaScript','src'=>root_link_url("modules/$MODULE/func.js")));
    echo tag_tail('script')."\n";
    }
?>
  </head>
<body class="<?=$bodyclass?>">
<?
  }

function page_end($body=true) {
?>
</body>
</html>
<?
  }

function check_access($access='') {
  global $USER,$CFG;
  if ($access=='') return true;
  if (!strstr($USER['access'],$access)) {
?>
<script language="JavaScript">
location.href="<?="$CFG[PATH]/"?>";
</script>
<? die(); }
  }

function self_link($par='') {
  global $PAGE,$MODULE,$UNIT,$CFG;
  if ($MODULE=='pages' and isset($PAGE)) $url="$CFG[PATH]/page/$PAGE";
  else $url=$CFG['SITE_URL']."$CFG[PATH]/m/$MODULE/$UNIT";
  if ($par!='') $url.='?'.$par;
  return $url;
  }
function self_to($par='',$text='',$a=array()) {
  $a['href']=self_link($par);
  return tag_head('a',$a).$text.tag_tail('a');
  }

function dir_files($add='') {
  global $CFG,$PAGE,$MODULE;
  if ($MODULE=='pages' and isset($PAGE)) $dir="modules/pages/page/$PAGE/";
  else $dir="modules/$MODULE/$add";
  return $dir;
  }

function link_files($name='') {
  global $CFG,$PAGE,$MODULE;
  if ($MODULE=='pages' and isset($PAGE)) $url="$CFG[PATH]/modules/pages/page/$PAGE/$name";
  else $url="$CFG[PATH]/modules/$MODULE/$name";
  return $CFG['SITE_URL'].$url;
  }
function link_file($name) {
  return link_files($name);
  }
function link_to_file($fname,$title='',$target='') {
  $a=array('href'=>link_file($fname));
  if ($target!='') $a['target']=$target;
  if ($title!='') $a['title']=$title;
  return tag_head('a',$a).$title.tag_tail('a');
  }
function root_link_url($url) {
  global $CFG;
  if ($url=='') return('');
  if (!strstr($url,'http://') and !strstr($url,'https://') and !strstr($url,'javascript:'))
    $url=$CFG['SITE_URL']."$CFG[PATH]/$url";
  return($url);
  }
function root_link_to($link,$text,$title='',$class='',$target='') {
  $a=array();
  if ($link[0]=='^') {
    $a['target']='_blank';
    $link=substr($link,1);
    }
  if ($title!='') $a['title']=$title;
  if ($class!='') $a['class']=$class;
  if ($target!='') $a['target']=$target;
  $a['href']=root_link_url($link);
  return tag_head('a',$a).$text.tag_tail('a');
  }
function module_url($code,$unit,$par='') {
  $url=root_link_url("m/$code/$unit");
  if ($par!='') $url.="?$par";
  return $url;
  }
function module_to($code,$unit,$text,$b=array()) {
  $a=array();
  $a['href']=module_url($code,$unit);
  $a=array_merge($a,$b);
  return tag_head('a',$a).$text.tag_tail('a');
  }
function link_url($url) {
  global $CFG,$MODULE;
  if ($url=='') return('');
  if ($url[0]=='^') {
    $a['target']='_blank';
    $url=substr($url,1,strlen($url-1));
    }
  if (!strstr($url,'http://') and !strstr($url,'https://') and !strstr($url,'javascript:')) {
    if ($MODULE=='pages') $url="$CFG[PATH]/p/$url";
    else $url="$CFG[PATH]/m/$MODULE/$url";
    $url=$CFG['SITE_URL'].$url;
    }
  return($url);
  }
function link_to($link,$text,$title='',$class='',$target='') {
  $a=array();
  if ($title!='') $a['title']=$title;
  if ($class!='') $a['class']=$class;
  if ($target!='') $a['target']=$target;
  $a['href']=link_url($link);
  return tag_head('a',$a).$text.tag_tail('a');
  }
function link_js($act,$text,$title='',$class='') {
  $a=array();
  if ($title!='') $a['title']=$title;
  if ($class!='') $a['class']=$class;
  $a['href']="javascript:void($act)";
  return tag_head('a',$a).$text.tag_tail('a');
  }

function page_title() {
  global $CFG,$MODULE,$UNIT,$PAGE;
  if ($MODULE=='pages' and isset($PAGE) and $p=get_sql_value('pages.title',"url='page/$PAGE'")) return($p);
  $fname="modules/$MODULE/titles.php";
  if (file_exists($fname)) {
    $TITLE=array();
    include($fname);
    if (isset($TITLE[$UNIT])) return($TITLE[$UNIT]);
    };
  return($CFG['SITE_TITLE']);
  }

function tpl($name,$a=array()) {
  global $MODULE,$UNIT,$TEMPLATE;
  $n=$UNIT.'_'.$name;
  if (!isset($TEMPLATE[$MODULE][$n])) {
    return 'Template '.$MODULE.'_'.$n.' not exists';
    }
  $s=$TEMPLATE[$MODULE][$n];
  foreach ($a as $p=>$v) $s=str_ireplace("%$p",$v,$s);
  return($s);
  }

function page_parse_static($m) {
  $func=strtolower($m[1]);
  if (function_exists($func)) {
    return($func());
    }
  else return("(Unknown '$m[1]')");
  }

function page_parse_dynamic($m) {
  $func=strtolower($m[1]);
  if (function_exists($func)) {
    $deli=strstr($m[2],'|')?'|':',';
    return(call_user_func_array($func,explode($deli,$m[2])));
    }
  else return("(Unknown '$m[1]'='$m[2]')");
  }

function page_parse($content) {
  $content=preg_replace_callback('/\{([A-Z0-9_]+?)=(.+)\}/','page_parse_dynamic',$content);
  $content=preg_replace_callback('/\{([A-Z0-9_]+)\}/','page_parse_static',$content);
  return($content);
  }

function page_parse_file($file) {
  global $CFG,$PAR,$USER,$MODULES,$THEME;
  if (!file_exists($file)) return("File '$file' not found");
  ob_start(NULL,2000000);
  include($file);
  $s=ob_get_contents();
  ob_end_clean();
  return page_parse($s);
  }

function module_content($code='',$unit='') {
  global $MODULES;
  if ($code=='') $code=$GLOBALS['MODULE']; else { $GLOBALS['_MODULE']=$GLOBALS['MODULE']; $GLOBALS['MODULE']=$code; }
  if ($unit=='') $unit=$GLOBALS['UNIT']; else { $GLOBALS['_UNIT']=$GLOBALS['UNIT']; $GLOBALS['UNIT']=$unit; }
  $content='';
  $p=get_sql_row('pages',"module='$code' and unit='$unit'");
  if ($p and strlen($p['data'])) {
    if (function_exists('theme_page_start')) $content.=call_user_func('theme_page_start');
    $content.=page_parse($p['data']);
    if (function_exists('theme_page_end')) $content.=call_user_func('theme_page_end');
    }
  else {
    if (file_exists("modules/$code/$unit.php")) $file="modules/$code/$unit.php";
    elseif (file_exists("modules/$code/$unit.html")) $file="modules/$code/$unit.html";
    else $file=0;
    if ($file) $content=page_parse_file($file);
    }
  if (isset($GLOBALS['_MODULE'])) { $GLOBALS['MODULE']=$GLOBALS['_MODULE']; unset($GLOBALS['_MODULE']); }
  if (isset($GLOBALS['_UNIT'])) { $GLOBALS['UNIT']=$GLOBALS['_UNIT']; unset($GLOBALS['_UNIT']); }
  return($content);
  }

function module_box($code) {
  return(module_content($code,'box'));
  }
function module_row($code) {
  return(module_content($code,'row'));
  }

function modules($pos) {
  global $MODULES,$CFG;
  $pos=strtoupper($pos);
  $z=explode(' ',$CFG['POS'][$pos]);
  $s='';
  foreach ($z as $x) {
    list($m,$u)=explode('.',$x,2);
    if (!$MODULES[$m]['active']) continue;
    $s.=module_content($m,$u);
    }
  return($s);
  }

$FUNCS='
if ($LIST=get_sql_array(\'funcs.src.code\',"dst=\'$GLOBALS[MODULE]\' and code=\'$CODE\'")) {
  foreach ($LIST as $SRC=>$CODE) if ($MODULES[$SRC][\'active\']) { $FUNC=strtoupper($CODE); include("modules/$SRC/funcs.php"); }
  }
';
